import EMItemService from '@/service/emitem/emitem-service';
import { Verify } from '@/utils/verify/verify';


/**
 * 根据物品获取采购员
 *
 * @export
 * @class GetREMPLogicBase
 */
export default class GetREMPLogicBase {

    /**
     * 名称
     * 
     * @memberof  GetREMPLogicBase
     */
    private name:string ="GetREMP";

    /**
     * 唯一标识
     * 
     * @memberof  GetREMPLogicBase
     */
    private id:string = "5fb2529b96756f8b8f92743fc263b70f";

    /**
     * 默认参数名称
     * 
     * @memberof  GetREMPLogicBase
     */
    private defaultParamName:string = "Default";

    /**
     * Creates an instance of  GetREMPLogicBase.
     * 
     * @param {*} [opts={}]
     * @memberof  GetREMPLogicBase
     */
    constructor(opts: any = {}) {
        
    }


    /**
     * 计算0节点结果
     * 
     * @param params 传入参数
     */
    public compute0Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算1节点结果
     * 
     * @param params 传入参数
     */
    public compute1Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算2节点结果
     * 
     * @param params 传入参数
     */
    public compute2Cond(params:any):boolean{
        return true;
    }

    /**
     * 执行逻辑
     * 
     * @param context 应用上下文
     * @param params 传入参数
     */
    public onExecute(context:any,params:any,isloading:boolean){
        return this.executeBegin(context,params,isloading);
    }


    /**
    * 准备物品ID
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam1(context:any,params:any,isloading:boolean){
        // 准备参数节点
        Object.assign(params,{emitemid:params.itemid});
        Object.assign(context,{emitem:params.itemid});
        if(this.compute2Cond(params)){
            return this.executeDeaction1(context,params,isloading);   
        }
    }

    /**
    * 开始
    * 
    * @param params 传入参数
    */
    private async executeBegin(context:any,params:any,isloading:boolean){
        //开始节点
        if(this.compute1Cond(params)){
            return this.executePrepareparam1(context,params,isloading);   
        }
    }

    /**
    * 获取物品信息
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDeaction1(context:any,params:any,isloading:boolean){
        // 行为处理节点
        let result: any;
        const targetService:EMItemService = new EMItemService();
        if (targetService['Get'] && targetService['Get'] instanceof Function) {
            result = await targetService['Get'](context,params, false);
        }
        if(result && result.status == 200){
            Object.assign(params,result.data);
        if(this.compute0Cond(params)){
            return this.executePrepareparam2(context,params,isloading);   
        }
        }
    }

    /**
    * 回填采购员
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam2(context:any,params:any,isloading:boolean){
        // 准备参数节点
        Object.assign(params,{rempid:params.empid});
        Object.assign(context,{emwplist:params.empid});
        Object.assign(params,{rempname:params.empname});
        return params;
    }


}